
<?php

/**
 * GepFluxo
 *
 * This class has been auto-generated by the Doctrine ORM Framework
 *
 * @package    DbModel
 * @subpackage Model
 * @author     alessandrobartels - 19/04/2011 08:29:05 <development@setforms.com>
 * @version    Release: SVN: $Id: Builder.php 6508 2009-10-14 06:28:49Z jwage $
 */
class GepFluxo extends DaoGepFluxo
{


    /**
     * Consulta dados de uma situa?.
     *
     * @param integer $nrorg     N?o da Organiza?.
     * @param integer $situacao  N?o da situa?.
     * @param integer $tipo_soli Tipo da solicita?.
     *
     * @return Ambigous <multitype:, NULL, TkModelEntity>|boolean
     */
    public static function consultaFluxosSituacao($nrorg, $situacao, $tipo_soli){
        try {
            $sql = "SELECT NRFLUXO, TXRESPOSTAFLUXO, NRORDEMFLUXO, NRORG FROM GEP_FLUXO
                    WHERE (NRORG = $nrorg)
                      AND
                      (NRSITUACAO = $situacao)
                      AND
                      (NRTIPOSOLICITACAO IS NULL OR NRTIPOSOLICITACAO = $tipo_soli)
                      AND
                      (
                          (NRTIPOSOLIPROX IS NULL)
                              OR
                          (NRSITUACAOPROX IS NULL AND NRTIPOSOLIPROX <> $tipo_soli)
                              OR
                          (NRSITUACAOPROX IS NOT NULL AND NRSITUACAOPROX <> $situacao AND NRTIPOSOLIPROX = $tipo_soli)
                              OR
                          (NRSITUACAOPROX IS NOT NULL AND NRSITUACAOPROX = $situacao AND NRTIPOSOLIPROX <> $tipo_soli)
                              OR
                          (NRSITUACAOPROX IS NOT NULL AND NRSITUACAOPROX <> $situacao AND NRTIPOSOLIPROX <> $tipo_soli)
                      )
                    UNION
                    SELECT 9999999999 NRFLUXO, 'Troca de operador' TXRESPOSTAFLUXO, 9999999999 NRORDEMFLUXO, NRORG
                      FROM GEP_PARAMGERALGEP
                     WHERE NRORG = $nrorg
                    ORDER BY NRORDEMFLUXO";

            return $sql;

        } catch (Exception $e) {
            showClassError($e, __FUNCTION__, __LINE__);
            return false;
        }
    }


    /**
     * Consulta dados de um fluxo.
     *
     * @param integer $nrorg N?o da organiza?.
     * @param integer $fluxo N?o do fluxo.
     *
     * @return Ambigous <boolean, mixed, NULL>
     */
    public static function consultaFluxo($nrorg, $fluxo){
        try {
            $obj = self::getObjectByWhere(
                'NRORG = ? AND NRFLUXO = ?',
                array(
                 $nrorg,
                 $fluxo,
                )
            );

            return $obj;

        } catch (Exception $e) {
            showClassError($e, __FUNCTION__, __LINE__);
            return false;
        }
    }


    /**
     * Consulta fluxos de encaminhamento.
     *
     * @return string
     */
    public static function consultaQueryFluxo(){
        $sql = "SELECT GEP_FLUXO.*,
                       SITU.NMSITUACAO AS NRSITUACAO__LABEL,
                       SITU.TXPERGUNTAENCA,
                       TPSOLI.NMTIPOSOLICITACAO AS NRTIPOSOLICITACAO__LABEL,
                       MOT.NMMOTIVOFLUXO AS NRMOTIVOFLUXO__LABEL,
                       SITUPROX.NMSITUACAO AS NRSITUACAOPROX__LABEL,
                       TPSOLIPROX.NMTIPOSOLICITACAO AS NRTIPOSOLIPROX__LABEL,
                       OPERULTATU.NMOPERADOR AS CDOPERULTATU__LABEL,
                       OPERINCLUSAO.NMOPERADOR AS CDOPERINCLUSAO__LABEL
                FROM GEP_FLUXO

                JOIN GEP_SITUACAO SITU
                ON  GEP_FLUXO.NRSITUACAO = SITU.NRSITUACAO
                AND GEP_FLUXO.NRORG = SITU.NRORG

                LEFT JOIN GEP_TIPOSOLICITACAO TPSOLI
                ON  GEP_FLUXO.NRTIPOSOLICITACAO = TPSOLI.NRTIPOSOLICITACAO
                AND GEP_FLUXO.NRORG = TPSOLI.NRORG

                LEFT JOIN GEP_MOTIVOFLUXO MOT
                ON  GEP_FLUXO.NRMOTIVOFLUXO = MOT.NRMOTIVOFLUXO
                AND GEP_FLUXO.NRORG = MOT.NRORG

                LEFT JOIN GEP_SITUACAO SITUPROX
                ON  GEP_FLUXO.NRSITUACAOPROX = SITUPROX.NRSITUACAO
                AND GEP_FLUXO.NRORG = SITUPROX.NRORG

                LEFT JOIN GEP_TIPOSOLICITACAO TPSOLIPROX
                ON  GEP_FLUXO.NRTIPOSOLIPROX = TPSOLIPROX.NRTIPOSOLICITACAO
                AND GEP_FLUXO.NRORG = TPSOLIPROX.NRORG

                LEFT JOIN OPERADOR OPERINCLUSAO
                ON OPERINCLUSAO.CDOPERADOR = GEP_FLUXO.CDOPERINCLUSAO
                AND OPERINCLUSAO.NRORG = GEP_FLUXO.NRORG

                LEFT JOIN OPERADOR OPERULTATU
                ON  GEP_FLUXO.CDOPERULTATU = OPERULTATU.CDOPERADOR
                AND GEP_FLUXO.NRORG = OPERULTATU.NRORG

                WHERE WHERE_PLACEHOLDER
                AND   FILTER_PLACEHOLDER

                ORDER BY GEP_FLUXO.NRORDEMFLUXO";
        return $sql;
    }


}